# -*- coding: utf-8 -*-
#
# File: AnnotatableMetadata.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.2
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATSchemaEditorNG.SchemaEditor import SchemaEditor
from Products.AnnotatableMetadata.config import *


from Products.CMFCore.utils import UniqueObject


##code-section module-header #fill in your manual code here
from Products.ATSchemaEditorNG.config import TOOL_NAME as ATSE_TOOL_NAME
from interfaces import IAnnotatedMetadata
##/code-section module-header

schema = Schema((

    StringField(
        name='html_keywords',
        widget=StringWidget(
            label='Html_keywords',
            label_msgid='AnnotatableMetadata_label_html_keywords',
            i18n_domain='AnnotatableMetadata',
        )
    ),

    #<p>if checked while saving, the schema gets updated from the
    #ATSchemaEditorNG using the updateSchema method</p>
    BooleanField(
        name='update_schema',
        default=False,
        widget=BooleanField._properties['widget'](
            label="Update Schema?",
            description="Click this to update the metadata schema from the ATSchemaEditor",
            label_msgid='AnnotatableMetadata_label_update_schema',
            description_msgid='AnnotatableMetadata_help_update_schema',
            i18n_domain='AnnotatableMetadata',
        ),
        schemata="update"
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

AnnotatableMetadata_schema = BaseFolderSchema.copy() + \
    getattr(SchemaEditor, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class AnnotatableMetadata(UniqueObject, BaseFolder, SchemaEditor):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),) + (getattr(SchemaEditor,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'Annotatable Metadata Tool'

    meta_type = 'AnnotatableMetadata'
    portal_type = 'portal_annotatablemetadata'
    allowed_content_types = ['metadataset'] + list(getattr(SchemaEditor, 'allowed_content_types', []))
    filter_content_types = 1
    global_allow = 0
    #content_icon = 'AnnotatableMetadata.gif'
    immediate_view = 'annotatablemetadata_view'
    default_view = 'annotatablemetadata_view'
    suppl_views = ()
    typeDescription = "Annotatable Metadata Tool"
    typeDescMsgId = 'description_edit_annotatablemetadata'
    #toolicon = 'AnnotatableMetadata.gif'


    actions =  (


       {'action': "string:${object_url}/annotatablemetadata_view",
        'category': "object",
        'id': 'view',
        'name': 'View',
        'permissions': ("Manage portal",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/atse_editor",
        'category': "object",
        'id': 'editor_view',
        'name': 'Edit field definitions',
        'permissions': ("Modify portal content",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = AnnotatableMetadata_schema

    ##code-section class-header #fill in your manual code here
    __replaceable__ = 1
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseFolder.__init__(self,'portal_annotatablemetadata')
        self.setTitle('Annotatable Metadata Tool')

        ##code-section constructor-footer #fill in your manual code here
        SchemaEditor.atse_init(self)
        ##/code-section constructor-footer


    # tool should not appear in portal_catalog
    def at_post_edit_script(self):
        self.unindexObject()

        ##code-section post-edit-method-footer #fill in your manual code here
        #import pdb; pdb.set_trace()
        if self.getUpdate_schema():
            self.updateSchema()
            self.setUpdate_schema(False)
        ##/code-section post-edit-method-footer


    # Methods

    security.declarePublic('getValue')
    def getValue(self, ob, name, default=None):
        """Return a value from an objects annotations by name (key)
        """
        a_ob = IAnnotatedMetadata(ob)
        return a_ob.getValue(name, default)

    # Manually created methods

    security.declarePublic('updateSchema')
    def updateSchema(self):
        """<p>Updates the schema manually</p>
        """
        for elem in self.objectValues('metadataset'):
            elem.updateSchemaFromEditor()


def modify_fti(fti):
    # Hide unnecessary tabs (usability enhancement)
    for a in fti['actions']:
        if a['id'] in ['metadata', 'sharing', 'edit']:
            a['visible'] = 0
    return fti

registerType(AnnotatableMetadata, PROJECTNAME)
# end of class AnnotatableMetadata

##code-section module-footer #fill in your manual code here
##/code-section module-footer



