from zope.interface import Interface
#from zope import schema


class IAnnotatableMetadata(Interface):
    """Marker interface for content that allows annotated metadata.
    """

class IAnnotatedMetadata(Interface):
    """Provide access to the metadata annotations of an IAnnotatableMetadata object.
    """

    def setMetadataValues():
        """Sets the values given for existing metadata definitions
        """

    def getValue(name):
        """Gets a value by name from the annotation storage
        """

    def getKeys():
        """ Retrieves all available keys in the annotation storage
        """


class IAnnotatedMetadataView(Interface):
    """Browser view for annotated metadata.
    """

    def fields():
        """Return the Fields to be used by the view
        """


class IRemoteSchema(Interface):
    """ encapsules a content object but redirects access to the schema to another object
    """

    def Schema():
        """ Returns the schema of the remote object
        """