import os, sys

import glob
import doctest
import unittest
from Globals import package_home
from base import AnnotatableMetadataFunctionalTestCase
from Testing.ZopeTestCase import FunctionalDocFileSuite as Suite

from Products.AnnotatableMetadata.config import product_globals

OPTIONFLAGS = (doctest.REPORT_ONLY_FIRST_FAILURE |
               doctest.ELLIPSIS |
               doctest.NORMALIZE_WHITESPACE)

def list_doctests():
    home = package_home(product_globals)
    # find txt files in home
    readme_txt = os.path.sep.join([home, 'README.txt'])
    # find txt files in test dir
    filenames = [filename for filename in
            glob.glob(os.path.sep.join([home, 'tests', '*.txt']))]
    filenames.append(readme_txt)
    return filenames


def test_suite():
    filenames = list_doctests()
    return unittest.TestSuite(
        [Suite(os.path.basename(filename),
               optionflags=OPTIONFLAGS,
               package='Products.AnnotatableMetadata',
               test_class=AnnotatableMetadataFunctionalTestCase)
         for filename in filenames]
        )